use32
  macro   align value { rb (value-1) - ($ + value-1) mod value }

               org    0x0

               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x20000                 ; memory for app
               dd     0x20000                 ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon

stack_size=4096

START:                          ; start of execution
        mov ecx,20000h-fin-stack_size
        mov edi,fin
        call add_mem
        mov ecx,16384
        call malloc
        mov [work_area],edi
        call colorprecalc
	call draw_window
                ; at first, draw the window

still:

    mov  eax,10                 ; wait here for event
    int  0x40
    push still
    cmp  eax,1                  ; redraw request ?
    je   draw_window
    cmp  eax,2                  ; key in buffer ?
    je   read_string
    cmp  eax,3                  ; button in buffer ?
    je   button
    ret

  button:                       ; button
    mov  eax,-1                 ; close this program
    int  0x40

read_string:

    mov  edi,name_string
    call print_strings

    mov  edi,name_string-1
  f10:
    inc edi
    cmp byte[edi],0
    jne f10
  f11:
    mov  eax,10
    int  0x40
    cmp  eax,2
    jz   fbu
    jmp  rs_done
  fbu:
    mov  eax,2
    int  0x40
    shr  eax,8
    cmp  eax,13
    je   rs_done
    cmp  eax,8
    jnz  nobsl
    cmp  edi,name_string
    jz   f11
    dec  edi
    mov  [edi],byte 0;'_'
    call print_strings
    jmp  f11
  nobsl:
    cmp  eax,31
    jbe  f11
    cmp  eax,97
    jb   keyok
    sub  eax,32
  keyok:
    mov  [edi],al
    call print_strings

    add  edi,1
    mov  esi,name_string
    add  esi,45
    cmp  esi,edi
    jnz  f11

   rs_done:

    mov  al,0
    mov  ebx,name_string+90
   newz:
    stosb
    cmp  edi,ebx
    jb   newz
    call print_strings
load_image:
    mov esi,name_string
    call open
    test eax,eax
    jz .end2
    call jpeg_info
    test ebp,ebp
    jz .end
    mov dword [ebp+draw_ptr],put_image
    call jpeg_display
    jmp jpeg_close
 .end2:
    call close
 .end:
    ret

print_strings:

    pusha
    mov  eax,13              ; clear text area
    mov  ebx,4*65536+6*80
    mov  ecx,296*65536+12
    mov  edx,0xffffff
    int  0x40

    mov  eax,4               ; icon text
    mov  ebx,4*65536+296
    mov  ecx,0x000000
    mov  edx,name_string
    mov  esi,80
    int  0x40
    popa
    ret

put_image:
        pushad
        cmp ax,480
        jnc .l1
        cmp bx,272
        jnc .l1
        add ax,4
        add bx,20
        push ax
        push bx
        push cx
        push dx
        pop ecx
        pop edx
        mov ebx,edi
        mov eax,7
        int 40h
      .l1:
        popad
        ret


;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40
; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  ebx,480+8                 ; [x start] *65536 + [x size]
    mov  ecx,272+4+16+16              ; [y start] *65536 + [y size]
    mov  edx,0x03ffffff            ; color of work area RRGGBB,8->color gl
    mov  esi,0x808899ff            ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x008899ff            ; color of frames    RRGGBB
    int  0x40
    call load_image
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40
    ret


include 'filelib.asm'
include 'memlib.asm'
include 'jpeglib.asm'
; DATA AREA
jpeg_st: dd  0
work_area: dd 0
tcolor   dd  0x000000
btcolor  dd  0x224466+0x808080
name_string: db '/rd/1/test.jpg',0
rb 100

text:
 db '  FILE:                                                               '
 db 'x'

align 4

        rgb16: db 0,4,8,13,17,21,25,29,34,38,42,46,50,55,59,63
        rgb4: db 0,21,42,63
include 'jpegdat.asm'
align 4
iniciomemoria:
        dd -(iniciomemoria+4),-(iniciomemoria+4),(iniciomemoria+4),.l1,0
     .l1 dd 0

fin:


I_END:



